m4_divert(-1)

# C++ skeleton for Bison

# Copyright (C) 2002, 2003, 2004, 2005, 2006 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301  USA

m4_include(b4_pkgdatadir/[c++.m4])

### v3c

#- bison 2.4.1 migration
m4_ifset([m4_fst], [], [m4_define([m4_fst], [$1])])dnl
m4_ifset([b4_parser_class_name], [], [m4_define([b4_parser_class_name],
          [b4_percent_define_get([[parser_class_name]])])])dnl
dnl
## Required vars
m4_ifset([b4_scanner_include], [], [m4_fatal([b4_scanner_include must be defined])])dnl
m4_ifset([b4_scanner_class_name], [], [m4_fatal([b4_scanner_class_name must be defined])])dnl
dnl
## Optional vars
m4_ifset([b4_parser_data_members], [], [m4_define([b4_parser_data_members], [])])dnl
m4_ifset([SemanticValue], [], [m4_define([SemanticValue], [FlexxTokenPtr])])dnl
m4_ifset([b4_location_type], [], [m4_define([b4_location_type], [Span])])dnl
m4_ifset([b4_make_location_from_scanner], [], [m4_define([b4_make_location_from_scanner], [b4_location_type[](m_scanner, m_scanner)])])dnl
m4_ifset([b4_parser_bases], [], [m4_define([b4_parser_bases], [])])dnl
m4_ifset([b4_parser_public_members], [], [m4_define([b4_parser_public_members], [])])dnl
m4_ifset([b4_scanner_params],[],[m4_define([b4_scanner_params],[])])dnl
m4_ifset([b4_parser_ctor],[],[m4_define([b4_parser_ctor],[])])dnl
dnl
## Break with bison %union
m4_ifset([b4_stype], [m4_fatal(b4_skeleton[: using %union is deprecated])])dnl
dnl
## Utils
m4_define([b4_nargs],[$#])dnl
m4_define([b4_argn], [m4_if($1, 1, [[$2]],
	[b4_argn(m4_decr([$1]), m4_shift(m4_shift($@)))])])dnl
m4_define([b4_first], [b4_argn([1], $@)])dnl
m4_define([m4_lst], [b4_argn([$#], $@)])dnl
m4_define([m4_noop], [])dnl
m4_define([m4_lower], [m4_translit($1, [A-Z], [a-z])])dnl
m4_define([b4_all], [$@])dnl
m4_define([b4_public], [, public b4_argn([1], $@)])dnl
m4_ifset([b4_wrap_location],[],[m4_define([b4_wrap_location],[$1])])dnl
m4_if([
m4_map_sep2 is like m4_map_sep but it also inserts the seperator at the start if
the list isn't empty.
Example:
    m4_map_sep2(MACRO, [SEPARATOR], LIST)
])dnl
m4_define([m4_map_sep2],
[m4_if($3, [], [],
	[$2[]$1(m4_fst($3))[]m4_map([$2[]$1], m4_cdr($3))])])dnl
m4_ifset([b4_namespace_list], [m4_define([b4_namespace],
	[m4_map_sep([m4_fst],[::], [b4_namespace_list])])])dnl
dnl
m4_define([m4_reverse], [m4_if([$#], [0], , [$#], [1], [[$1]],
[m4_reverse(m4_shift($@)), [$1]])])dnl
dnl
m4_define([b4_namespace_open],
	[m4_foreach([_b4_namespace_open], [b4_namespace_list],
[namespace _b4_namespace_open {
])])dnl
m4_define([b4_namespace_close],
	[m4_foreach([_b4_namespace_close], [m4_reverse(b4_namespace_list)],
[} // namespace _b4_namespace_close
])])dnl
m4_define([b4_parser_prefix], [m4_lower([m4_map_sep([m4_fst],[_], [b4_namespace_list])])_[]m4_lower([b4_parser_class_name])])dnl
### v3c

# The header is mandatory.
b4_defines_if([],
              [m4_fatal(b4_skeleton[: using %defines is mandatory])])dnl

# Backward compatibility.
m4_define([b4_location_constructors])dnl

# We do want M4 expansion after # for CPP macros.
m4_changecom()dnl
m4_divert(0)dnl
m4_esyscmd([echo ">>> bison_calc.m4 : ]b4_parser_prefix[_tokens.hpp" 1>&2])dnl
@output(b4_dir_prefix[]b4_parser_prefix[]_tokens.hpp@)
[#if !defined(]b4_parser_prefix[_tokens_hpp_included)
#define ]b4_parser_prefix[_tokens_hpp_included
]b4_namespace_open[
/// Tokens.
struct ]b4_parser_class_name[Tokens
{
	]b4_token_enums(b4_tokens)[
};
]b4_namespace_close[

#endif // #ifndef ]b4_parser_prefix[_tokens_hpp_included]
b4_defines_if(
[@output(b4_spec_defines_file@)
m4_esyscmd([echo ">>> bison_calc.m4 : ]b4_spec_defines_file[" 1>&2])dnl
b4_copyright([Skeleton interface for Bison LALR(1) parsers in C++],
  [2002, 2003, 2004, 2005, 2006])
[
/* C++ LALR(1) parser skeleton written by Philip Ashmore.  */

#if !defined(]b4_parser_prefix[_hpp_included)
#define ]b4_parser_prefix[_hpp_included

#include "]b4_scanner_include["
#include <string>
#include <iostream>
#include <v3c/parse_stack.hpp>

/* First part of user declarations.  */
]b4_user_pre_prologue

[#include <v3c/span.hpp>
]dnl
m4_ifdef([b4_null_define],[b4_null_define
])dnl
b4_namespace_open[

/// A Bison parser.
class ]b4_parser_class_name[: public ParserTokens]m4_map_sep2([m4_fst],[, public ], [b4_parser_bases])[
{
public:
	friend class ]b4_scanner_class_name[;

	/// Token type.
	typedef ]b4_parser_class_name[Tokens::yytokentype token_type;

	/// Build a parser object.
	]b4_parser_class_name[ (]b4_parse_param_decl[);
	virtual ~]b4_parser_class_name[ ();

	/// Parse.
	/// \returns  0 iff parsing succeeded.
	virtual int parse();

	/// The current debugging stream.
	std::ostream& debug_stream() const;
	/// Set the current debugging stream.
	void set_debug_stream(std::ostream &);

	/// The current debugging level.
	bool lex_debug() const;
	bool parse_debug() const;
	/// Set the current debugging level.
	void set_lex_debug(bool b);
	void set_parse_debug(bool b);

	void switch_streams(istream * in, ostream * out);
	inline void yyerrok() { yyerrstatus_ = 0; }

	]b4_parser_public_members[
protected:
	/// Report a syntax error.
	/// \param loc    where the syntax error is found.
	/// \param msg    a description of the syntax error.
	virtual void error(const ]b4_location_type[ & loc, const std::string& msg)
	{
		stringstream ss;
		ss << "At " << ]b4_wrap_location([loc])[ << " : " << msg << '.';
		throw runtime_error(ss.str());
	}
private:
	/// Generate an error message.
	/// \param state   the state where the error occurred.
	/// \param tok     the look-ahead token.
	virtual std::string yysyntax_error_ (int yystate]dnl
					b4_error_verbose_if([, int tok])[);

	/// Value of the look-ahead.
	]SemanticValue[ yylval;

	/// Our scanner.
	]b4_scanner_class_name[ m_scanner;

	/// State numbers.
	typedef int state_type;
	/// State stack type.
	typedef parse_stack<state_type>    state_stack_type;
	/// Value stack type.
	typedef parse_stack<]SemanticValue[> semantic_stack_type;

	/// The state stack.
	state_stack_type yystate_stack_;
	/// The value stack.
	semantic_stack_type yysemantic_stack_;

	/// Internal symbol numbers.
	typedef ]b4_int_type_for([b4_translate])[ token_number_type;
	/* Tables.  */
	/// For a state, the index in \a yytable_ of its portion.
	static const ]b4_int_type_for([b4_pact])[ yypact_[];
	static const ]b4_int_type(b4_pact_ninf, b4_pact_ninf)[ yypact_ninf_;

	/// For a state, default rule to reduce.
	/// Unless\a  yytable_ specifies something else to do.
	/// Zero means the default is an error.
	static const ]b4_int_type_for([b4_defact])[ yydefact_[];

	static const ]b4_int_type_for([b4_pgoto])[ yypgoto_[];
	static const ]b4_int_type_for([b4_defgoto])[ yydefgoto_[];

	/// What to do in a state.
	/// \a yytable_[yypact_[s]]: what to do in state \a s.
	/// - if positive, shift that token.
	/// - if negative, reduce the rule which number is the opposite.
	/// - if zero, do what YYDEFACT says.
	static const ]b4_int_type_for([b4_table])[ yytable_[];
	static const ]b4_int_type(b4_table_ninf, b4_table_ninf)[ yytable_ninf_;

	static const ]b4_int_type_for([b4_check])[ yycheck_[];

	/// For a state, its accessing symbol.
	static const ]b4_int_type_for([b4_stos])[ yystos_[];

	/// For a rule, its LHS.
	static const ]b4_int_type_for([b4_r1])[ yyr1_[];
	/// For a rule, its RHS length.
	static const ]b4_int_type_for([b4_r2])[ yyr2_[];

	/// For a symbol, its name in clear.
	static const char* const yytname_[];

	/// Convert the symbol name \a n to a form suitable for a diagnostic.
	virtual std::string yytnamerr_ (const char *n);

	/// A type to store symbol numbers and -1.
	typedef ]b4_int_type_for([b4_rhs])[ rhs_number_type;
	/// A `-1'-separated list of the rules' RHS.
	static const rhs_number_type yyrhs_[];
	/// For each rule, the index of the first RHS symbol in \a yyrhs_.
	static const ]b4_int_type_for([b4_prhs])[ yyprhs_[];
	/// For each rule, its source line number.
	static const ]b4_int_type_for([b4_rline])[ yyrline_[];
	/// For each scanner token number, its symbol number.
	static const ]b4_int_type_for([b4_toknum])[ yytoken_number_[];
	/// Report on the debug stream that the rule \a r is going to be reduced.
	virtual void yy_reduce_print_ (int r);
	/// Print the state stack on the debug stream.
	virtual void yystack_print_ ();

	/// Convert a scanner token number \a t to a symbol number.
	token_number_type yytranslate_(int t) const;

	/// Pop \a n symbols the three stacks.
	inline void yypop_ (unsigned int n = 1);

	/* Constants.  */
	static const int yyeof_;
	/* LAST_ -- Last index in TABLE_.  */
	static const int yylast_;
	static const int yynnts_;
	static const int yyempty_;
	static const int yyfinal_;
	static const int yyterror_;
	static const int yyerrcode_;
	static const int yyntokens_;
	static const unsigned int yyuser_token_number_max_;
	static const token_number_type yyundef_token_;

	/* Debugging.  */
	bool yydebug_;
	std::ostream* yycdebug_;

	/* Error handling.  */
	int yynerrs_;
	int yyerrstatus_;

]b4_parse_param_vars[]dnl
b4_parser_data_members[]dnl
[protected:
]b4_parser_protected_members[]dnl
[private:
]b4_parser_private_members[]dnl
[};

]b4_namespace_close[
]m4_ifset([b4_global_tokens_and_yystype],
[b4_token_defines(b4_tokens)])dnl
[#endif // #if !defined(]b4_parser_prefix[_hpp_included)]
])dnl
@output(b4_parser_file_name@)
m4_esyscmd([echo ">>> bison_calc.m4 : ]b4_parser_file_name[" 1>&2])dnl
b4_copyright([Skeleton implementation for Bison LALR(1) parsers in C++],
  [2009])
b4_defines_if([
#include "@basename(]b4_spec_defines_file[@)"])[

/* First part of user declarations.  */
]b4_user_pre_prologue[

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG ]b4_debug_flag[
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE ]b4_error_verbose_flag[
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE ]b4_token_table[
#endif

/* yylloc_default -- Set cur to span from rhs[1] to rhs[n].
   If n is 0, then set cur to the empty location which ends
   the previous symbol: rhs[0] (always defined).  */

#ifndef yylloc_default_defined
#define yylloc_default_defined
template< typename S, typename T >
void yylloc_default(S & cur, const T & rhs, unsigned int n)
{
	if(!cur)
		return;
	if(n) {
		cur->begin = rhs[1]->begin;
		cur->end   = rhs[n]->end;
	}else{
		cur->begin = cur->end = rhs[0]->end;
	}
}
#endif /*#ifndef yylloc_default_defined*/

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#define YYUSE(e) ((void) (e))

/* A pseudo ostream that takes yydebug_ into account.  */
# define YYCDEBUG							\
  for (bool yydebugcond_ = yydebug_; yydebugcond_; yydebugcond_ = false)	\
    (*yycdebug_)

# ifndef YY_SYMBOL_PRINT
#   define YY_SYMBOL_PRINT(Title, Value) \
do { \
	if(yydebug_) \
		*yycdebug_ << Title << ' ' << Value << endl; \
} while (false)
# endif

# define YY_REDUCE_PRINT(Rule) \
do { \
	if(yydebug_) \
		yy_reduce_print_(Rule); \
} while (false)

# define YY_STACK_PRINT() \
do { \
	if (yydebug_) \
		yystack_print_ (); \
} while (false)

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab

]b4_namespace_open[
/* Return YYSTR after stripping away unnecessary quotes and
	backslashes, so that it's suitable for yyerror.  The heuristic is
	that double-quoting is unnecessary unless the string contains an
	apostrophe, a comma, or backslash (other than backslash-backslash).
	YYSTR is taken from yytname.  */
std::string
]b4_parser_class_name[::yytnamerr_ (const char *yystr)
{
	if (*yystr == '"') {
		std::string yyr = "";
		char const *yyp = yystr;

		for (;;)
			switch (*++yyp) {
			case '\'':
			case ',':
				goto do_not_strip_quotes;
	
			case '\\':
				if (*++yyp != '\\')
				goto do_not_strip_quotes;
				/* Fall through.  */
			default:
				yyr += *yyp;
				break;
	
			case '"':
				return yyr;
			}
		do_not_strip_quotes: ;
	}

	return yystr;
}

/// Build a parser object.
]b4_parser_class_name::b4_parser_class_name[ (]b4_parse_param_decl[)
: ParserTokens()]m4_map_sep2([m4_do], [
, ], [b4_parser_bases])[
, yylval()
, m_scanner(]b4_scanner_params[)
, yystate_stack_()
, yysemantic_stack_()
, yydebug_(false)
, yycdebug_(&std::cerr)]b4_parse_param_cons[
]b4_parser_ctor[{
}

]b4_parser_class_name::~b4_parser_class_name[ ()
{
}

void
]b4_parser_class_name[::yypop_ (unsigned int n)
{
	yystate_stack_.pop (n);
	yysemantic_stack_.pop (n);
}

std::ostream&
]b4_parser_class_name[::debug_stream () const
{
	return *yycdebug_;
}

void
]b4_parser_class_name[::set_debug_stream (std::ostream& o)
{
	yycdebug_ = &o;
}

bool
]b4_parser_class_name[::lex_debug() const
{
	return m_scanner.debug();
}
bool
]b4_parser_class_name[::parse_debug() const
{
	return yydebug_;
}

void
]b4_parser_class_name[::set_lex_debug(bool b)
{
	m_scanner.set_debug(b);
}
void
]b4_parser_class_name[::set_parse_debug(bool b)
{
	yydebug_ = b;
}

void
]b4_parser_class_name[::switch_streams(istream * in, ostream * out)
{
	m_scanner.switch_streams(in, out);
}
int
]b4_parser_class_name[::parse ()
{
	/// Look-ahead and look-ahead in internal form.
	int yychar = yyempty_;
	int yytoken = 0;

	/* State.  */
	int yyn;
	int yylen = 0;
	int yystate = 0;

	// Error handling.
	yynerrs_ = yyerrstatus_ = 0;

	/// The locations where the error started and ended.
	]b4_location_type[ yyerror_range_instances[2];
	]b4_location_type[ *yyerror_range[2] = { yyerror_range_instances, yyerror_range_instances+1};;

	/// $$.
	]SemanticValue[ yyval;

	int yyresult;

	YYCDEBUG << "Starting parse" << std::endl;

]m4_ifdef([b4_initial_action], [
m4_pushdef([b4_dollar_dollar], [yylval])dnl
    /* User initialization code.  */
    b4_initial_action
m4_popdef([b4_dollar_dollar])dnl
m4_popdef([b4_at_dollar])dnl
])dnl

[  /* Initialize the stacks.  The initial state will be pushed in
		yynewstate, since the latter expects the semantical and the
		location values to have been already stored, initialize these
		stacks with a primary value.  */
	yystate_stack_ = state_stack_type(0);
	yysemantic_stack_ = semantic_stack_type(0);
	yysemantic_stack_.push(yylval);

	/* New state.  */
yynewstate:
	yystate_stack_.push (yystate);
	YYCDEBUG << "Entering state " << yystate << std::endl;
	goto yybackup;

	/* Backup.  */
yybackup:

	/* Try to take a decision without look-ahead.  */
	yyn = yypact_[yystate];
	if (yyn == yypact_ninf_)
		goto yydefault;

    /* Read a look-ahead token.  */
	if (yychar == yyempty_) {
		YYCDEBUG << "Reading a token: ";
		try {
			yylval = m_scanner.]b4_c_function_call([read],SemanticValue)[;
			yychar = yylval->id();
		} catch(const ]SemanticValue[ & e) { // Nested return.
			yylval = e;
			yychar = yylval->id();
		} catch(const v3c::scanner_result & e) {
			yychar = e.result;
			yylval = 0; // Shouldn't do this.
		}
	}


	/* Convert token to internal form.  */
	if (yychar <= yyeof_) {
		yychar = yytoken = yyeof_;
		YYCDEBUG << "Now at end of input." << std::endl;
	}else{
		yytoken = yytranslate_ (yychar);
		YY_SYMBOL_PRINT("Next token is", yylval);
	}

	/* If the proper action on seeing token YYTOKEN is to reduce or to
		detect an error, take that action.  */
	yyn += yytoken;
	if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yytoken)
		goto yydefault;

	/* Reduce or error.  */
	yyn = yytable_[yyn];
	if (yyn <= 0) {
		if (yyn == 0 || yyn == yytable_ninf_)
			goto yyerrlab;
		yyn = -yyn;
		goto yyreduce;
	}

	/* Accept?  */
	if (yyn == yyfinal_)
		goto yyacceptlab;

	/* Shift the look-ahead token.  */
	YY_SYMBOL_PRINT("Shifting", yylval);

	/* Discard the token being shifted unless it is eof.  */
	if (yychar != yyeof_)
		yychar = yyempty_;

	yysemantic_stack_.push (yylval);

	/* Count tokens shifted since error; after three, turn off error
		status.  */
	if (yyerrstatus_)
		--yyerrstatus_;

	yystate = yyn;
	goto yynewstate;

	/*-----------------------------------------------------------.
	| yydefault -- do the default action for the current state.  |
	`-----------------------------------------------------------*/
yydefault:
	yyn = yydefact_[yystate];
	if (yyn == 0)
		goto yyerrlab;
	goto yyreduce;

	/*-----------------------------.
	| yyreduce -- Do a reduction.  |
	`-----------------------------*/
yyreduce:
	yylen = yyr2_[yyn];
	/* If YYLEN is nonzero, implement the default value of the action:
		`$$ = $1'.  Otherwise, use the top of the stack.

		Otherwise, the following line sets YYVAL to garbage.
		This behavior is undocumented and Bison
		users should not rely upon it.  */
	if (yylen)
		yyval = yysemantic_stack_[yylen - 1];
	else
		yyval = yysemantic_stack_[0];

	{
		slice<]SemanticValue[, semantic_stack_type> slice(yysemantic_stack_, yylen);
		if(yylen)
			yylloc_default(yyval, slice, yylen);
    }
    YY_REDUCE_PRINT (yyn);
    switch (yyn)
      {
	]b4_user_actions[
	default: break;
      }
	YY_SYMBOL_PRINT("-> $$ =", yyval);

    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    yysemantic_stack_.push(yyval);

    /* Shift the result of the reduction.  */
    yyn = yyr1_[yyn];
    yystate = yypgoto_[yyn - yyntokens_] + yystate_stack_[0];
    if (0 <= yystate && yystate <= yylast_
	&& yycheck_[yystate] == yystate_stack_[0])
      yystate = yytable_[yystate];
    else
      yystate = yydefgoto_[yyn - yyntokens_];
    goto yynewstate;

	/*------------------------------------.
	| yyerrlab -- here on detecting error |
	`------------------------------------*/
yyerrlab:
	/* If not already recovering from an error, report this error.  */
	if (!yyerrstatus_) {
		++yynerrs_;
		error(yylval ? * yylval : ]b4_make_location_from_scanner[
			, yysyntax_error_(yystate]b4_error_verbose_if([, yytoken])[));
      }

	*yyerror_range[0] = *yylval;
	if (yyerrstatus_ == 3) {
		/* If just tried and failed to reuse look-ahead token after an
		 error, discard it.  */

		if (yychar <= yyeof_) {
			/* Return failure if at end of input.  */
			if (yychar == yyeof_)
				YYABORT;
		}else{
			YY_SYMBOL_PRINT("Error: discarding", yylval);
			yychar = yyempty_;
		}
	}

	/* Else will try to reuse look-ahead token after shifting the error
		token.  */
	goto yyerrlab1;

	/*---------------------------------------------------.
	| yyerrorlab -- error raised explicitly by YYERROR.  |
	`---------------------------------------------------*/
yyerrorlab:

	/* Pacify compilers like GCC when the user code never invokes
		YYERROR and the label yyerrorlab therefore never appears in user
		code.  */
	if (false)
		goto yyerrorlab;

	*yyerror_range[0] = *yysemantic_stack_[yylen - 1];
	/* Do not reclaim the symbols of the rule which action triggered
		this YYERROR.  */
	yypop_ (yylen);
	yylen = 0;
	yystate = yystate_stack_[0];
	goto yyerrlab1;

	/*-------------------------------------------------------------.
	| yyerrlab1 -- common code for both syntax error and YYERROR.  |
	`-------------------------------------------------------------*/
yyerrlab1:
	yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

	for(;;) {
		yyn = yypact_[yystate];
		if(yyn != yypact_ninf_) {
			yyn += yyterror_;
			if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_) {
				yyn = yytable_[yyn];
				if (0 < yyn)
				break;
			}
		}

		/* Pop the current state because it cannot handle the error token.  */
		if(yystate_stack_.size() == 1)
			YYABORT;

		*yyerror_range[0] = *yysemantic_stack_[0];
		YY_SYMBOL_PRINT("Error: popping", yysemantic_stack_[0]);
		yypop_();
		yystate = yystate_stack_[0];
		YY_STACK_PRINT();
	}

	if (yyn == yyfinal_)
		goto yyacceptlab;

	*yyerror_range[1] = *yylval;
	// Using YYLLOC is tempting, but would change the location of
	// the look-ahead.  YYLOC is available though.
	yylloc_default(yyval, (yyerror_range - 1), 2);
	yysemantic_stack_.push (yylval);

	/* Shift the error token.  */
	YY_SYMBOL_PRINT ("Shifting", yysemantic_stack_[0]);

	yystate = yyn;
	goto yynewstate;

	/* Accept.  */
yyacceptlab:
	yyresult = 0;
	goto yyreturn;

	/* Abort.  */
yyabortlab:
	yyresult = 1;
	goto yyreturn;

yyreturn:
	if (yychar != yyeof_ && yychar != yyempty_)
		YY_SYMBOL_PRINT("Cleanup: discarding lookahead", yylval);

	/* Do not reclaim the symbols of the rule which action triggered
		this YYABORT or YYACCEPT.  */
	yypop_ (yylen);
	while (yystate_stack_.size() != 1) {
		YY_SYMBOL_PRINT("Cleanup: popping", yysemantic_stack_[0]);
		yypop_ ();
	}

	return yyresult;
}

// Generate an error message.
std::string
]b4_parser_class_name[::yysyntax_error_ (int yystate]dnl
b4_error_verbose_if([, int tok])[)
{
	std::string res;
	YYUSE (yystate);
#if YYERROR_VERBOSE
	int yyn = yypact_[yystate];
	if (yypact_ninf_ < yyn && yyn <= yylast_) {
	/* Start YYX at -YYN if negative to avoid negative indexes in
	   YYCHECK.  */
	int yyxbegin = yyn < 0 ? -yyn : 0;

	/* Stay within bounds of both yycheck and yytname.  */
	int yychecklim = yylast_ - yyn + 1;
	int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
	int count = 0;
	for (int x = yyxbegin; x < yyxend; ++x)
		if (yycheck_[x + yyn] == x && x != yyterror_)
			++count;

	// FIXME: This method of building the message is not compatible
	// with internationalization.  It should work like yacc.c does it.
	// That is, first build a string that looks like this:
	// "syntax error, unexpected %s or %s or %s"
	// Then, invoke YY_ on this string.
	// Finally, use the string as a format to output
	// yytname_[tok], etc.
	// Until this gets fixed, this message appears in English only.
	res = "syntax error, unexpected ";
	res += yytnamerr_ (yytname_[tok]);
	if (count < 5)
	  {
	    count = 0;
	    for (int x = yyxbegin; x < yyxend; ++x)
	      if (yycheck_[x + yyn] == x && x != yyterror_)
		{
		  res += (!count++) ? ", expecting " : " or ";
		  res += yytnamerr_ (yytname_[x]);
		}
	  }
      }
    else
#endif
      res = YY_("syntax error");
    return res;
  }


  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
  const ]b4_int_type(b4_pact_ninf, b4_pact_ninf) b4_parser_class_name::yypact_ninf_ = b4_pact_ninf[;
  const ]b4_int_type_for([b4_pact])[
  ]b4_parser_class_name[::yypact_[] =
  {
    ]b4_pact[
  };

  /* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
     doesn't specify something else to do.  Zero means the default is an
     error.  */
  const ]b4_int_type_for([b4_defact])[
  ]b4_parser_class_name[::yydefact_[] =
  {
    ]b4_defact[
  };

  /* YYPGOTO[NTERM-NUM].  */
  const ]b4_int_type_for([b4_pgoto])[
  ]b4_parser_class_name[::yypgoto_[] =
  {
    ]b4_pgoto[
  };

  /* YYDEFGOTO[NTERM-NUM].  */
  const ]b4_int_type_for([b4_defgoto])[
  ]b4_parser_class_name[::yydefgoto_[] =
  {
    ]b4_defgoto[
  };

  /* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule which
     number is the opposite.  If zero, do what YYDEFACT says.  */
  const ]b4_int_type(b4_table_ninf, b4_table_ninf) b4_parser_class_name::yytable_ninf_ = b4_table_ninf[;
  const ]b4_int_type_for([b4_table])[
  ]b4_parser_class_name[::yytable_[] =
  {
    ]b4_table[
  };

  /* YYCHECK.  */
  const ]b4_int_type_for([b4_check])[
  ]b4_parser_class_name[::yycheck_[] =
  {
    ]b4_check[
  };

  /* STOS_[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
  const ]b4_int_type_for([b4_stos])[
  ]b4_parser_class_name[::yystos_[] =
  {
    ]b4_stos[
  };

#if YYDEBUG
  /* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
     to YYLEX-NUM.  */
  const ]b4_int_type_for([b4_toknum])[
  ]b4_parser_class_name[::yytoken_number_[] =
  {
    ]b4_toknum[
  };
#endif

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
  const ]b4_int_type_for([b4_r1])[
  ]b4_parser_class_name[::yyr1_[] =
  {
    ]b4_r1[
  };

  /* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
  const ]b4_int_type_for([b4_r2])[
  ]b4_parser_class_name[::yyr2_[] =
  {
    ]b4_r2[
  };

  /* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
     First, the terminals, then, starting at \a yyntokens_, nonterminals.  */
  const char*
  const ]b4_parser_class_name[::yytname_[] =
  {
    ]b4_tname[
  };

  /* YYRHS -- A `-1'-separated list of the rules' RHS.  */
  const ]b4_parser_class_name[::rhs_number_type
  ]b4_parser_class_name[::yyrhs_[] =
  {
    ]b4_rhs[
  };

  /* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
     YYRHS.  */
  const ]b4_int_type_for([b4_prhs])[
  ]b4_parser_class_name[::yyprhs_[] =
  {
    ]b4_prhs[
  };

  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
  const ]b4_int_type_for([b4_rline])[
  ]b4_parser_class_name[::yyrline_[] =
  {
    ]b4_rline[
  };

  // Print the state stack on the debug stream.
  void
  ]b4_parser_class_name[::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (state_stack_type::const_iterator i = yystate_stack_.begin ();
	 i != yystate_stack_.end (); ++i)
      *yycdebug_ << ' ' << *i;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  ]b4_parser_class_name[::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    /* Print the symbols being reduced, and their result.  */
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
	       << " (line " << yylno << "), \n";
    /* The symbols being reduced.  */
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT("   $" << yyi + 1 << " =",
		       ]b4_rhs_value(yynrhs, yyi + 1)[);
  }

  /* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
  ]b4_parser_class_name[::token_number_type
  ]b4_parser_class_name[::yytranslate_ (int t) const
  {
    static
    const token_number_type
    translate_table[] =
    {
      ]b4_translate[
    };
    if ((unsigned int) t <= yyuser_token_number_max_)
      return translate_table[t];
    else
      return yyundef_token_;
  }

  const int ]b4_parser_class_name[::yyeof_ = 0;
  const int ]b4_parser_class_name[::yylast_ = ]b4_last[;
  const int ]b4_parser_class_name[::yynnts_ = ]b4_nterms_number[;
  const int ]b4_parser_class_name[::yyempty_ = -2;
  const int ]b4_parser_class_name[::yyfinal_ = ]b4_final_state_number[;
  const int ]b4_parser_class_name[::yyterror_ = 1;
  const int ]b4_parser_class_name[::yyerrcode_ = 256;
  const int ]b4_parser_class_name[::yyntokens_ = ]b4_tokens_number[;

  const unsigned int ]b4_parser_class_name[::yyuser_token_number_max_ = ]b4_user_token_number_max[;
  const ]b4_parser_class_name[::token_number_type ]b4_parser_class_name[::yyundef_token_ = ]b4_undef_token_number[;

]b4_namespace_close[

]b4_epilogue
dnl
m4_divert(-1)
