%{
// Copyright (C) 2012  Philip Ashmore (contact@philipashmore.com)
// License: LGPLv3.  See LICENSE.txt for the full license.

#include "parser.hpp"
%}

%option debug nodefault nounput never-interactive
%option c++ 8bit warn noyywrap yylineno
%option yyclass="v3c::cmdline::Scanner" outfile="scanner.cpp"

%%
-[^ \t=\'\"-]+               return make_token(SHORT_ARG);
--[^ \t=\'\"-]+              return make_token(LONG_ARG);
-[^ \t='"]+=                 return make_token(LONG_ARG_EQUALS);
" --"                        return make_token(POSITIONAL_END);
"\""(([^\"]*)((\\.)*))*"\""  return make_token(DQUOTE_STRING);
"'"([^']*)"'"                return make_token(SQUOTE_STRING);
[ \t]+                       return make_token(SPACE);
\n                           LexerError("Single lines only allowed.");
[^ \t'"]+                    return make_token(VALUE);
.                            LexerError("Unexpected input \"%s\"", yytext);
%%
