// Copyright (C) 2009  Philip Ashmore (contact@philipashmore.com)
// License: LGPLv3.  See LICENSE.txt for the full license.

#include <fstream>
#include "calc_parser.hpp"

using namespace std;
using namespace v3c;

namespace calc {

void Token::stream_value(ostream & s) const
{
	switch(type()) {
	case eInt:
		s << int_value();
		break;
	case eString:
		s << string_value();
		break;
	default:
		break;
	}
}
void Token::stream(ostream & s) const
{
	stream_span(s);
	s << '[' << id() << "] : ";
	stream_value(s);
}

int Parser::parse(const char * filename)
{
	int ret;
	if(!strcmp(filename, "-")) {
		m_scanner.new_file("<cin>");
		switch_streams(&cin, (ostream *)0);
		ret = parse();
	}else{
		ifstream is(filename);
		if(is.bad())
			return 1;
		m_scanner.new_file(filename);
		switch_streams(&is, (ostream *)0);
		ret = parse();
	}
	return ret;
}

void Scanner::before_rule()
{
	//cerr << "### before_rule : " << *this << " \"" << yytext << '"' << endl;
}
void Scanner::after_rule()
{
	//cerr << "### after_rule(0) : " << *this << " \"" << yytext << '"' << endl;
	Flexx::after_rule();
	//cerr << "### after_rule(1) : " << *this << " \"" << yytext << '"' << endl;
}

} // namespace calc
