// Copyright (C) 2009  Philip Ashmore (contact@philipashmore.com)
// License: LGPLv3.  See LICENSE.txt for the full license.

#include <fstream>
#include <v3c/string_utils.hpp>
#include "bisonx_parser.hpp"

namespace v3c {
namespace bisonx {
namespace impl {

using namespace v3c;
using namespace std;

int Parser::parse(Grammar & g_, const char * filename)
{
	grammar = & g_;
	ifstream is(filename);
	if(!is.good())
		throw runtime_error(string_inline_printf("Couldn't open file \"%s\""
			, filename));
	m_scanner.new_file(filename);
	switch_streams(&is, (ostream *)0);
	int ret = parse();
	return ret;
}

} // namespace impl
} // namespace bisonx
} // namespace v3c
