// Copyright (C) 2009  Philip Ashmore (contact@philipashmore.com)
// License: LGPLv3.  See LICENSE.txt for the full license.
// bisonx grammars have literal tokens below 256, tokens starting at 300,
// followed by rules, so the first rule index is stored.

// Grammar codes
.equ eRule,			0
.equ eProduction,	1
.equ eRepeatToken,	2
.equ eRepeatRule,	3
.equ eErrorToken,	4
.equ eErrorRule,	5

//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
// Psuedo-code macros
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.macro xErrorToken text:req, symbol:req
// text, error-recovery-symbol
// length 6
	.byte eErrorToken,0
	.word \text,\symbol
.endm
.macro xErrorRule text:req, symbol:req
// text, error-recovery-symbol
// length 6
	.byte eErrorRule,0
	.word \text,\symbol
.endm

.macro xProduction count:req, id:req, action:req, symbols:vararg
// nSymbols, action, symbol+
// length 6 + n*2
	.byte eProduction,\count
	.word \id, \action
	.irp symbol,\symbols
	.word \symbol
	.endr
.endm
.macro xRule count:req, id:req, func:req, range:vararg
// rId, mergefunc index, n.
// The n productions are indexed as rId0, rId1, rId2...
// length 6 + n*2
	.byte eRule,\count
	.word \id,\func
	.irp xRuleId, \range
	.word \id\()\xRuleId
	.endr
.endm

.macro xRepeatToken token:req, a1:req, a2:req, a3:req
// token, set-up-action, match-action, no-matches-action
// length 10
	.byte eRepeatToken,0
	.word \token, \a1, \a2, \a3
.endm
.macro xRepeatRule rule:req, a1:req, a2:req, a3:req
// rule, set-up-action, match-action, no-matches-action
// length 10
	.byte eRepeatRule,0
	.word \rule, \a1, \a2, \a3
.endm
