# Copyright (C) 2009  Philip Ashmore (contact@philipashmore.com)
# License: LGPLv3.  See LICENSE.txt for the full license.

.include "bisonx.s"

	.section	.rodata

// Action indeces
.equ _, -1 # default
.equ A,  0
.equ B,  1
.equ C,  2
.equ D,  3
.equ E,  4
.equ F,  5
.equ G,  6
.equ H,  7
.equ I,  8
.equ J,  9
.equ K, 10
.equ L, 11

// terminal tokens
.equ tId,  300
.equ tEqu, 301
.equ tNum, 302

// non-terminals (rules)
.equ rUnit,			303
.equ rUnit0,		304
.equ rExp,			305
.equ rAssignments,	306
.equ rAssignment,	307
.equ rAssignment0,	308
.equ rExp0,			309
.equ rExp1,			310
.equ rExp2,			311
.equ rExp3,			312
.equ rExp4,			313
.equ rExp5,			314

	.align 8
.symbol0:
	.string "id"
.symbol1:
	.string ":="
.symbol2:
	.string "num"
.symbol3:
	.string "unit"
.symbol4:
	.string "unit.0"
.symbol5:
	.string "exp"
.symbol6:
	.string "assignments"
.symbol7:
	.string "assignment"
.symbol8:
	.string "assignment.0"
.symbol9:
	.string "exp.0"
.symbol10:
	.string "exp.1"
.symbol11:
	.string "exp.2"
.symbol12:
	.string "exp.3"
.symbol13:
	.string "exp.4"
.symbol14:
	.string "exp.5"

	.align 8
.bisonx_calc_symbol_names_table:
	.quad .symbol0
	.quad .symbol1
	.quad .symbol2
	.quad .symbol3
	.quad .symbol4
	.quad .symbol5
	.quad .symbol6
	.quad .symbol7
	.quad .symbol8
	.quad .symbol9
	.quad .symbol10
	.quad .symbol11
	.quad .symbol12
	.quad .symbol13
	.quad .symbol14
.unit:
	xRule 1, rUnit, _, 0
.unit.0:
	// unit: assignments exp {A}
	xProduction 2, rUnit0, A, rAssignments, rExp
.assignments:
	// I'm breaking the notation here - B sets up the accumulator for the result.
	// assignments: assignments<B> assignment {C}
	//            | / * Nothing.  * /       {D}
	xRepeatRule rAssignment,B,C,D
.assignment:
	xRule 1, rAssignment, _, 0
.assignment.0:
	// assignment: "identifier" ":=" exp {E}
	xProduction 3, rAssignment0, E, tId, tEqu, rExp
.exp:
	xRule 6, rExp, F, 0,1,2,3,4,5
.exp.0:
	// exp: exp '+' exp {G}
	xProduction 3, rExp0, G, rExp, '+', rExp
.exp.1:
	// | exp '-' exp {H}
	xProduction 3, rExp1, H, rExp, '-', rExp
.exp.2:
	// | exp '*' exp {I}
	xProduction 3, rExp2, I, rExp, '*', rExp
.exp.3:
	// | exp '/' exp {J}
	xProduction 3, rExp3, J, rExp, '/', rExp
.exp.4:
	// | "identifier" {K}
	xProduction 1, rExp4, K, tId
.exp.5:
	// | "number" {L}
	xProduction 1, rExp5, L, tNum
.bisonx_calc_rules_table:
	.quad .unit, .unit.0, .exp, .assignments, .assignment, .assignment.0
	.quad .exp.0, .exp.1, .exp.2, .exp.3, .exp.4, .exp.5

.globl bisonx_calc_grammar
	.data
	.align 16
	.type	bisonx_calc_grammar, @object
	.size	bisonx_calc_grammar, 24
bisonx_calc_grammar: /* The only non-local label */
	.word 303, 303
	.word 1, 2 /* pad */
	.quad .bisonx_calc_symbol_names_table
	.quad .bisonx_calc_rules_table
